
#ifndef __LL1PARSERGENERATOR_H
#define __LL1PARSERGENERATOR_H

#include "ContextFreeGrammar.h"

    namespace ContextFreeGrammars
    {

        class LL1ParserGenerator
        {

        protected:
            ContextFreeGrammar cfg;
            std::map<const NonTerminal*, std::set<Terminal*> > nonterminalfirst1;
            std::map<const NonTerminal*, std::set<Terminal*> > nonterminalfollow1;

            void CollectNonTerminalFirst1(const NonTerminal *targetnt);
            void CollectNonTerminalFollow1(const NonTerminal *targetnt);

            std::set<Terminal*> first1(const std::vector<Symbol*>& w) const;
            std::set<Terminal*> lookahead1(const NonTerminal* nt, const std::vector<Symbol*>& w) const;

        public:
            LL1ParserGenerator(const ContextFreeGrammar& cfg);
            ~LL1ParserGenerator();

            bool IsLL1Grammar() const;
            void GenerateRecursiveDescentParser(std::ostream& os) const;
        };

    }
#endif